version: '3'

services:
  app-department:
    image: 'department-service:latest'
    container_name: app-department-service
    build:
      context: ./departement-service
      dockerfile: Dockerfile
    depends_on:
      - db-department
    environment:
      - SPRING_DATASOURCE_URL=jdbc:postgresql://db-department:5432/department-service
      - SPRING_DATASOURCE_USERNAME=department-service
      - SPRING_DATASOURCE_PASSWORD=department-service
      - SPRING_JPA_HIBERNATE_DDL_AUTO=update
    expose:
      - "8080"
    ports:
      - "8080:8080"
    networks:
      - network

  db-department:
    image: 'postgres:15-alpine'
    container_name: db-department-service
    environment:
      - POSTGRES_USER=department-service
      - POSTGRES_PASSWORD=department-service
      - POSTGRES_DB=department-service
    networks:
      - network

  app-user:
    image: 'user-service:latest'
    container_name: app-user-service
    build:
      context: ./user-service
      dockerfile: Dockerfile
    depends_on:
      - db-user
      - app-department
    environment:
      - SPRING_DATASOURCE_URL=jdbc:postgresql://db-user:5432/user-service
      - SPRING_DATASOURCE_USERNAME=user-service
      - SPRING_DATASOURCE_PASSWORD=user-service
      - SPRING_JPA_HIBERNATE_DDL_AUTO=update
      - DEPARTMENT_SERVICE=app-department-service:8080
    expose:
      - "8082"
    ports:
      - "8082:8082"
    networks:
      - network

  db-user:
    image: 'postgres:15-alpine'
    container_name: db-user-service
    environment:
      - POSTGRES_USER=user-service
      - POSTGRES_PASSWORD=user-service
      - POSTGRES_DB=user-service
    networks:
      - network

  app-message:
    container_name: app-message-service
    build:
      context: ./message-service
      dockerfile: Dockerfile
    expose:
      - "8085"
    ports:
      - "8085:8085"
    links:
      - redis
    networks:
      - network

  redis:
      image: redis
      ports:
        - "6379:6379"
      networks:
        - network

networks:
  network:

#  docker-compose down -v --rmi all
#  docker-compose up --build --remove-orphans